"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _command = _interopRequireDefault(require("@ckeditor/ckeditor5-core/src/command"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createCodeSnippet(writer) {
  const codeSnippet = writer.createElement('codeSnippet'); // There must be at least one paragraph for the description to be editable.
  // See https://github.com/ckeditor/ckeditor5/issues/1464.

  writer.appendElement('paragraph', codeSnippet);
  return codeSnippet;
}

class InsertCodeSnippetCommand extends _command.default {
  execute() {
    this.editor.model.change(writer => {
      // Insert <pre>*</pre> at the current selection position
      // in a way that will result in creating a valid model structure.
      this.editor.model.insertContent(createCodeSnippet(writer));
    });
  }

  refresh() {
    const model = this.editor.model;
    const selection = model.document.selection;
    const allowedIn = model.schema.findAllowedParent(selection.getFirstPosition(), 'codeSnippet');
    this.isEnabled = allowedIn !== null;
  }

}

exports.default = InsertCodeSnippetCommand;